

# The Tale Jade Template Engine

> Finally a fully-functional, complete and clean port of the Jade language to PHP 
> * Abraham Lincoln*

The Tale Jade Template Engine brings the popular and powerful Templating-Language [Jade for Node.js](http://jade-lang.com) to PHP!

While previously there only existed ports of the existing Node.js Engine of Jade, **Tale Jade** is a completely new
implementation of the language utilizing the powerful and very specific features of PHP into your Jade application.

Build dynamic websites faster than ever before!

[Get started](http://jade.talesoft.io/getting-started) now or [dig into the dirt](http://jade.talesoft.io/hacking) by yourself!



## Supported features

Tale Jade for PHP does not only implement **every existing feature** of Jade there is, it also brings in some new ones!

### Supported official Node.js Jade Features
- [Tags](http://jade.talesoft.io/examples/tags)
- [Classes](http://jade.talesoft.io/examples/classes)
- [IDs](http://jade.talesoft.io/examples/ids)
- [Doctypes](http://jade.talesoft.io/examples/doctypes)
- [Attributes](http://jade.talesoft.io/examples/attributes)
- [Mixins](http://jade.talesoft.io/examples/mixins)
- [Blocks (with prepend, append and replace support)](http://jade.talesoft.io/examples/blocks)
- [Expressions & Escaping](http://jade.talesoft.io/examples/expressions)
- [Block Expansion](http://jade.talesoft.io/examples/block-expansion)
- [Assignments (&attributes)](http://jade.talesoft.io/examples/assignments)
- [Comments](http://jade.talesoft.io/examples/comments)
- [Inline Code](http://jade.talesoft.io/examples/code)
- [Inheritance](http://jade.talesoft.io/examples/inheritance)
- [Includes (with filters)](http://jade.talesoft.io/examples/includes)
- [Conditionals (if, else, elseif, case, when)](http://jade.talesoft.io/examples/conditionals)
- [Loops (each, while, do)](http://jade.talesoft.io/examples/loops)
- [Interpolation (with Element Interpolation)](http://jade.talesoft.io/examples/interpolation)
- [Filters](http://jade.talesoft.io/examples/filters)
- [Mixin Blocks](http://jade.talesoft.io/examples/mixin-blocks)
- [Variadics](http://jade.talesoft.io/examples/variadics)


### Supported Tale Jade Features
- [Named parameters](http://jade.talesoft.io/examples/named-parameters)
- [Attribute Stacking](http://jade.talesoft.io/examples/attribute-stacking)
- [Filter Maps](http://jade.talesoft.io/examples/filter-map)
- [Cross Assignments](http://jade.talesoft.io/examples/cross-assignments)


### Other, unrelated, cool features

- UTF-8 support via PHP's mb_* extension
- Hackable compiler, parser and lexer
- Huge amount of (optional) configuration possibilities
- Graceful compiler forgiving many mistakes (e.g. spaces around the code)
- Lightning fast and clean compilation
- Detailed error handling
- Renderer with different adapters (ease-of-use vs. performance)
- Intelligent expression parsing



## Getting started

To install and use the Tale Jade library, follow our [Getting Started](http://jade.talesoft.io/getting-started) guide.

If you're interested, you might also look into our in-depth guides:

- [In-depth configuration](http://jade.talesoft.io/configuration)
- [Hacking Tale Jade](http://jade.talesoft.io/hacking)



## There's more to come...

Tale Jade is actively used and developed in many projects and is improved constantly.

We don't stick to the Jade-convention, but we'll always provide compatibility to Node.js Jade to
help reducing confusion.

Planned features:
[ ] Import Attributes (`include some-file(some-var='some-value')`)
[ ] Helper Libraries
[ ] Aliases (Like mixins, just smaller)



## Get in touch

If you find a bug or miss a function, please use the [Issues](https://github.com/Talesoft/tale-jade/issues) on this page
to tell us about it. We will gladly hear you out :)

If you'd like to contribute, fork us, send us pull requests and we'll take a deep look at what you've been working at!
We're completely **Open Source**! You can do anything you like with out code, as long as you stick to the
**MIT-license** we've appended.

You can also contact us via E-Mail.

If you're interested in other projects, you might also contact us via E-Mail as well

**E-Mail: [info@talesoft.io](mailto:info@talesoft.io)**